#ifndef COMMONFUNCTIONS_CPP
#define COMMONFUNCTIONS_CPP
#include "datastore.h"
#include <QSqlQuery>
#include <QTextStream>


/*##################*/
int CountQuestions(QString TestName);
/*##################*/

void ResetPosition();

double CalculateResult()
{
    double result = 0;
    while (Questions->Previous !=0) Questions = Questions->Previous;
    while (Questions->Next != 0)
    {
         result = result + (Questions->Points / 4) * (4 -(
         Questions->UserAnswer %2 != Questions->CorrectAnswer %2 +
         ((Questions->UserAnswer / 2 == 1) | (Questions->UserAnswer / 2 == 3) | (Questions->UserAnswer / 2 == 5) | (Questions->UserAnswer / 2 == 7))
            != ((Questions->CorrectAnswer / 2 == 1) | (Questions->CorrectAnswer / 2 == 3) | (Questions->CorrectAnswer / 2 == 5) | (Questions->CorrectAnswer / 2 == 7)) +
         ((Questions->UserAnswer / 4 == 1) | (Questions->UserAnswer / 4 == 3))
            != ((Questions->CorrectAnswer / 4 == 1) | (Questions->CorrectAnswer/ 4 == 3)) +
         (Questions->UserAnswer / 8 == 1) != (Questions->CorrectAnswer / 8 == 1)));
    }
    return result;
}

void GenerateResultSet()
{
    ResultSet.clear();
    for (int i = 1; i <= CountQuestions(TestName); i++)
    {
        ResetPosition();
        while (Questions->QuestionNumber != i)
        {
            Questions = Questions->Next;
            QMessageBox msgBox;
            msgBox.setText(Questions->Question);
            msgBox.exec();
        }
        QString buf;
        QTextStream(&buf) << ":" << i << "-" << Questions->UserAnswer;
        QMessageBox msgBox2;
        msgBox2.setText(buf);
        msgBox2.exec();
        ResultSet.append(buf);
    }
}

int CountQuestions(QString TestName)
{
    QSqlQuery query;
    query.prepare("SELECT count(*) FROM Testy WHERE test_name = ?");
    query.bindValue( 0, TestName );
    query.exec();
    query.next();
    return query.value(0).toInt();
}

void SaveResultToSql()
{
    QSqlQuery query;
        query.prepare( "INSERT INTO Results (username, test_name, date, resultset) VALUES (?,?,?,?)");
        query.bindValue(0, StudentName);
        query.bindValue(1, TestName);
        query.bindValue(2, "nejako zjistit datum :-/");
        query.bindValue(3, ResultSet);
        query.exec();
        query.finish();
}

void ResetPosition()
{
    while (Questions->Previous !=0) Questions = Questions->Previous;
}

void CleanStruct()
{
    ResetPosition();
    while(Questions->Next)
    {
        Questions = Questions->Next;
        delete Questions->Previous;
    }
    delete Questions;
}
#endif // COMMONFUNCTIONS_CPP
