#ifndef TESTSELECTDIALOG_CPP
#define TESTSELECTDIALOG_CPP
#include "testselectdialog.h"
#include "ui_testselectdialog.h"
#include "datastore.h"

TestSelectDialog::TestSelectDialog(QWidget *parent) :
    QDialog(parent),
    m_ui(new Ui::TestSelectDialog)
{
    m_ui->setupUi(this);
    FillTests();
}

TestSelectDialog::~TestSelectDialog()
{
    delete m_ui;
}

void TestSelectDialog::changeEvent(QEvent *e)
{
    switch (e->type()) {
    case QEvent::LanguageChange:
        m_ui->retranslateUi(this);
        break;
    default:
        break;
    }
}

void TestSelectDialog::on_bOK_clicked()
{
    if(VerifyLogin()) {
        this->accept();
    }
}

bool TestSelectDialog::VerifyLogin()
{
    QSqlQuery query;
        query.prepare("SELECT password, teacher FROM Users WHERE username = ?");
        query.bindValue( 0, m_ui->leName->text());
        query.exec();
        query.next();
    if(!m_ui->lePassword->text().compare(query.value(0).toString())) {
        StudentName.clear();
        TestName.clear();
        Teacher = query.value(1).toBool();
        StudentName.append(m_ui->leName->text());
        TestName.append(m_ui->cbTest->currentText());
        return true;
    }
    else return false;
}

void TestSelectDialog::FillTests()
{
    QSqlQuery query("SELECT test_name FROM Testy GROUP BY test_name"); // SELECT test_name FROM Testy GROUP BY test_name
    while( query.next()) {
        m_ui->cbTest->addItem(query.value(0).toString(),query.value(0));
    }
    query.finish();
}

#endif
